<template>
  <div>
    <img style="width:110px;margin-right:10px" v-for="i in realSrcList" :src="videopic" @click="openvideo(i)"/>

    <el-dialog
      v-model="dialogVisible"
      title="预览"
      width="80%"
      append-to-body
      @close="closevideo"
    >
      <video autoplay controls
        :src="dialogImageUrl"
        style="display: block; max-width: 100%; margin: 0 auto"
      />
    </el-dialog>
  </div>
</template>

<script setup>
import { isExternal } from "@/utils/validate";
import videopic from '@/assets/images/Video.png'


const props = defineProps({
  src: {
    type: String,
    required: true
  },
  width: {
    type: [Number, String],
    default: ""
  },
  height: {
    type: [Number, String],
    default: ""
  }
});

const realSrc = computed(() => {
  let real_src = props.src.split(",")[0];
  if (isExternal(real_src)) {
    return real_src;
  }
  return import.meta.env.VITE_APP_BASE_API + real_src;
});

const realSrcList = computed(() => {


  let real_src_list = (props.src??'') .split(",");
  let srcList = [];
  ((real_src_list==null||real_src_list==""?[]:real_src_list)).forEach(item => {
    if (isExternal(item)) {
      return srcList.push(item);
    }
    return srcList.push(import.meta.env.VITE_APP_BASE_API + item);
  });
  return srcList;
});
const dialogVisible = ref(false);
const dialogImageUrl = ref("");

const openvideo = (src) => {
  dialogVisible.value = true;
  dialogImageUrl.value = src;
  var vs = document.getElementsByTagName('video');
  for (var i in vs) {
    try {
      var v = vs[i];
      v.play();
    } catch (e) { }

  }
}

function closevideo() {
  var vs = document.getElementsByTagName('video');
  for (var i in vs) {
    try {
      var v = vs[i];
      v.pause();
    } catch (e) { }

  }
}

const realWidth = computed(() =>
  typeof props.width == "string" ? props.width : `${props.width}px`
);

const realHeight = computed(() =>
  typeof props.height == "string" ? props.height : `${props.height}px`
);
</script>

<style lang="scss" scoped>
.el-image {
  border-radius: 5px;
  background-color: #ebeef5;
  box-shadow: 0 0 5px 1px #ccc;
  :deep(.el-image__inner) {
    transition: all 0.3s;
    cursor: pointer;
    &:hover {
      transform: scale(1.2);
    }
  }
  :deep(.image-slot) {
    display: flex;
    justify-content: center;
    align-items: center;
    width: 100%;
    height: 100%;
    color: #909399;
    font-size: 30px;
  }
}
</style>
